
Figure - Bug #118997
【AF】【EVT3】恢复出厂设置->跳过激活->重启设备->进入工厂模式->出现”Quickstep屡次停止运行"的提示
2023-07-07 16:18 - CD TEST-方永红

Status: CLOSED Start date: 2023-07-07

Priority: High Due date:

Assignee: CD TEST-方永红 % Done: 100%

Category: CD-APP Estimated time: 0.00 hour

Target version:

Need_Info: -- Found Version: 0120

Resolution: FIXED Degrated: --

Severity: Major Verified Version:

Reproducibility: Rarely Fixed Version: 2023-07-12

Test Type: ST Root cause: 问题原因：��launcher引用软键盘接口获取高度时，出现空指针

Description

【测试版本】

中控0092

副屏0120

【测试步骤】

1、恢复出厂设置

2、跳过激活

3、重启设备

4、进入工厂模式

->出现”Quickstep屡次停止运行"的提示

History

#1 - 2023-07-07 16:19 - CD TEST-方永红

- Category changed from CD-FW to CD-APP

- Assignee changed from CD FW 曹覃刚 to CD APP-王宏

- Priority changed from Normal to High

- Severity changed from Normal to Major

#2 - 2023-07-08 17:48 - CD APP-王宏

out/000112_merged_logcat_file.log:34620:07-07 16:04:26.902  4071  4071 E AndroidRuntime: Process: com.android.launcher3, PID: 4071

out/000112_merged_logcat_file.log:34621:07-07 16:04:26.902  4071  4071 E AndroidRuntime: java.lang.NullPointerException: Attempt to invoke virtual method 'int

com.android.server.wm.DisplayContent.getInputMethodWindowVisibleHeight()' on a null object reference

out/000112_merged_logcat_file.log:34622:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Parcel.createExceptionOrNull(Parcel.java:2431)

out/000112_merged_logcat_file.log:34623:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Parcel.createException(Parcel.java:2409)

out/000112_merged_logcat_file.log:34624:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Parcel.readException(Parcel.java:2392)

out/000112_merged_logcat_file.log:34625:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Parcel.readException(Parcel.java:2334)

out/000112_merged_logcat_file.log:34626:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.internal.view.IInputMethodManager$Stub$Proxy.getInputMethodWindowVisibleHeight(IInputMethodManager.java:939)

out/000112_merged_logcat_file.log:34627:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

android.view.inputmethod.InputMethodManager.getInputMethodWindowVisibleHeight(InputMethodManager.java:2960)

out/000112_merged_logcat_file.log:34628:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.quickstep.TouchInteractionService.onInputEvent(TouchInteractionService.java:591)

out/000112_merged_logcat_file.log:34629:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.quickstep.TouchInteractionService.$r8$lambda$QnySfMPM3HQvC_OREg1W70p37mY(Unknown Source:0)

out/000112_merged_logcat_file.log:34630:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at
com.android.quickstep.TouchInteractionService$$ExternalSyntheticLambda4.onInputEvent(Unknown Source:2)

out/000112_merged_logcat_file.log:34631:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.systemui.shared.system.InputChannelCompat$InputEventReceiver$1.onInputEvent(InputChannelCompat.java:74)

out/000112_merged_logcat_file.log:34632:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

android.view.InputEventReceiver.dispatchInputEvent(InputEventReceiver.java:260)

out/000112_merged_logcat_file.log:34633:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.MessageQueue.nativePollOnce(Native Method)

out/000112_merged_logcat_file.log:34634:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.MessageQueue.next(MessageQueue.java:335)

out/000112_merged_logcat_file.log:34635:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Looper.loopOnce(Looper.java:161)

out/000112_merged_logcat_file.log:34636:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Looper.loop(Looper.java:288)

out/000112_merged_logcat_file.log:34637:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.app.ActivityThread.main(ActivityThread.java:7880)

out/000112_merged_logcat_file.log:34638:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at java.lang.reflect.Method.invoke(Native Method)

out/000112_merged_logcat_file.log:34639:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.internal.os.RuntimeInit$MethodAndArgsCaller.run(RuntimeInit.java:548)

out/000112_merged_logcat_file.log:34640:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:1009)

out/000112_merged_logcat_file.log:34641:07-07 16:04:26.902  4071  4071 E AndroidRuntime: Caused by: android.os.RemoteException: Remote stack trace:

out/000112_merged_logcat_file.log:34642:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.server.wm.WindowManagerService$LocalService.getInputMethodWindowVisibleHeight(WindowManagerService.java:7633)

out/000112_merged_logcat_file.log:34643:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.server.inputmethod.InputMethodManagerService.getInputMethodWindowVisibleHeight(InputMethodManagerService.java:3905)

out/000112_merged_logcat_file.log:34644:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.internal.view.IInputMethodManager$Stub.onTransact(IInputMethodManager.java:466)

out/000112_merged_logcat_file.log:34645:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at

com.android.server.inputmethod.InputMethodManagerService.onTransact(InputMethodManagerService.java:1754)

out/000112_merged_logcat_file.log:34646:07-07 16:04:26.902  4071  4071 E AndroidRuntime:     at android.os.Binder.execTransactInternal(Binder.java:1179)

根据报错看是

WindowManagerService中的 DisplayContent 为null

@Override

        public int getInputMethodWindowVisibleHeight(int displayId) {

            synchronized (mGlobalLock) {

                final DisplayContent dc = mRoot.getDisplayContent(displayId);

                return dc.getInputMethodWindowVisibleHeight();

            }

        }

#3 - 2023-07-10 09:50 - CD APP-王宏

- Status changed from New to ASSIGNED

- Assignee changed from CD APP-王宏 to CD FW王武军

#4 - 2023-07-11 10:35 - CD FW王武军

【】当前状态

异常的发生是获取软键盘高度时，出现了空指针，而空指针的发生，可能有两方面的原因：

1）DisplayID是异常值；

2）RootWindowContainer中保存的DisplayContent有问题

日志中未记录上述的信息，并且本地加了日志后未复现问题。

现在的处理方法是：在获取的方法中做判空处理，同时针对可能出现问题的地方加上日志。

提交如下：

https://dev.thundercomm.com/gerrit/c/general/platform/frameworks/base/+/213566
【】下一步

测试在DB版本中验证，并记录日志。

#5 - 2023-07-11 14:41 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

213566 general/platform/frameworks/base Pre_figure_turbox-c2130c-la1.1-qssi12

-dev

wujun.wang@thundersoft.com

AF:SystemOptimization: fix NullPointerExceptionAdd logic to check Display id and DisplayContent.TC-RID: 1201-0205101IssueID:

TS-R-BUG-118997Change-Id: I51d886b77bc169d259ebf9cae3867749e07d8d41

#6 - 2023-07-11 14:44 - CD FW王武军

- Status changed from ASSIGNED to RESOLVED

- Assignee changed from CD FW王武军 to CD TEST-方永红

- % Done changed from 0 to 100

- Resolution changed from -- to FIXED

- Fixed Version set to 2023-07-12

- Root cause set to 问题原因：

launcher引用软键盘接口获取高度时，出现空指针

#7 - 2023-07-13 21:43 - IoT scm

Gerrit Merge Information：

ID Project Branch Uploader

214539 general/platform/frameworks/base Pre_figure_turbox-c2130c-la1.1-qssi12

-release_sorp

wangxl0510@thundersoft.com

AF:SystemOptimization: fix NullPointerExceptionAdd logic to check Display id and DisplayContent.TC-RID: 1201-0205101IssueID:

TS-R-BUG-118997Change-Id: I51d886b77bc169d259ebf9cae3867749e07d8d41(cherry picked from commit 2b5d4cc5c57fa7d97c1808d0929acf8056a2ffb2)

#8 - 2023-07-14 17:48 - CD TEST-方永红

0713DB\0122版本未复现，继续跟踪一个版本

#9 - 2023-07-24 13:55 - CD TEST-方永红

- Status changed from RESOLVED to VERIFIED

7.24

0123版本未复现此问题，先关闭
#10 - 2023-07-24 13:56 - CD TEST-方永红

- Status changed from VERIFIED to CLOSED
